#pragma once

#include "../main.h"

void (*get_instruction_impl(uint16_t instruction))(cpu_t*, uint16_t);
const char* get_instruction_name(uint16_t instruction);

#define R0    cpu->r[0]
#define R4    cpu->r[4]
#define R5    cpu->r[5]
#define R6    cpu->r[6]
#define R7    cpu->r[7]
#define R15   cpu->r[15]

void ADD(cpu_t* cpu, uint16_t instruction);
void ADDI(cpu_t* cpu, uint16_t instruction);
void ADDC(cpu_t* cpu, uint16_t instruction);
void ADDV(cpu_t* cpu, uint16_t instruction);
void AND(cpu_t* cpu, uint16_t instruction);
void ANDI(cpu_t* cpu, uint16_t instruction);
void ANDM(cpu_t* cpu, uint16_t instruction);
void BF(cpu_t* cpu, uint16_t instruction);
void BFS(cpu_t* cpu, uint16_t instruction);
void BRA(cpu_t* cpu, uint16_t instruction);
void BRAF(cpu_t* cpu, uint16_t instruction);
void BT(cpu_t* cpu, uint16_t instruction);
void BTS(cpu_t* cpu, uint16_t instruction);
void CLRMAC(cpu_t* cpu, uint16_t instruction);
void CLRS(cpu_t* cpu, uint16_t instruction);
void CLRT(cpu_t* cpu, uint16_t instruction);
void CMPEQ(cpu_t* cpu, uint16_t instruction);
void CMPGE(cpu_t* cpu, uint16_t instruction);
void CMPGT(cpu_t* cpu, uint16_t instruction);
void CMPHI(cpu_t* cpu, uint16_t instruction);
void CMPHS(cpu_t* cpu, uint16_t instruction);
void CMPPL(cpu_t* cpu, uint16_t instruction);
void CMPPZ(cpu_t* cpu, uint16_t instruction);
void CMPSTR(cpu_t* cpu, uint16_t instruction);
void CMPIM(cpu_t* cpu, uint16_t instruction);
void DIV0S(cpu_t* cpu, uint16_t instruction);
void DIV0U(cpu_t* cpu, uint16_t instruction);
void DIV1(cpu_t* cpu, uint16_t instruction);
void DMULS(cpu_t* cpu, uint16_t instruction);
void DMULU(cpu_t* cpu, uint16_t instruction);
void DT(cpu_t* cpu, uint16_t instruction);
void EXTSB(cpu_t* cpu, uint16_t instruction);
void EXTSW(cpu_t* cpu, uint16_t instruction);
void EXTUB(cpu_t* cpu, uint16_t instruction);
void EXTUW(cpu_t* cpu, uint16_t instruction);
void JMP(cpu_t* cpu, uint16_t instruction);
void LDCGBR(cpu_t* cpu, uint16_t instruction);
void LDCVBR(cpu_t* cpu, uint16_t instruction);
void LDCSGR(cpu_t* cpu, uint16_t instruction);
void LDCSSR(cpu_t* cpu, uint16_t instruction);
void LDCSPC(cpu_t* cpu, uint16_t instruction);
void LDCDBR(cpu_t* cpu, uint16_t instruction);
void LDCMGBR(cpu_t* cpu, uint16_t instruction);
void LDCMVBR(cpu_t* cpu, uint16_t instruction);
void LDCMSGR(cpu_t* cpu, uint16_t instruction);
void LDCMSSR(cpu_t* cpu, uint16_t instruction);
void LDCMSPC(cpu_t* cpu, uint16_t instruction);
void LDCMDBR(cpu_t* cpu, uint16_t instruction);
void LDSMACH(cpu_t* cpu, uint16_t instruction);
void LDSMACL(cpu_t* cpu, uint16_t instruction);
void LDSPR(cpu_t* cpu, uint16_t instruction);
void LDSMMACH(cpu_t* cpu, uint16_t instruction);
void LDSMMACL(cpu_t* cpu, uint16_t instruction);
void LDSMPR(cpu_t* cpu, uint16_t instruction);
void MACL_(cpu_t* cpu, uint16_t instruction);
void MACW(cpu_t* cpu, uint16_t instruction);
void MOV(cpu_t* cpu, uint16_t instruction);
void MOVBS(cpu_t* cpu, uint16_t instruction);
void MOVWS(cpu_t* cpu, uint16_t instruction);
void MOVLS(cpu_t* cpu, uint16_t instruction);
void MOVBL(cpu_t* cpu, uint16_t instruction);
void MOVWL(cpu_t* cpu, uint16_t instruction);
void MOVLL(cpu_t* cpu, uint16_t instruction);
void MOVBM(cpu_t* cpu, uint16_t instruction);
void MOVWM(cpu_t* cpu, uint16_t instruction);
void MOVLM(cpu_t* cpu, uint16_t instruction);
void MOVBP(cpu_t* cpu, uint16_t instruction);
void MOVWP(cpu_t* cpu, uint16_t instruction);
void MOVLP(cpu_t* cpu, uint16_t instruction);
void MOVBS0(cpu_t* cpu, uint16_t instruction);
void MOVWS0(cpu_t* cpu, uint16_t instruction);
void MOVLS0(cpu_t* cpu, uint16_t instruction);
void MOVBL0(cpu_t* cpu, uint16_t instruction);
void MOVWL0(cpu_t* cpu, uint16_t instruction);
void MOVLL0(cpu_t* cpu, uint16_t instruction);
void MOVI(cpu_t* cpu, uint16_t instruction);
void MOVWI(cpu_t* cpu, uint16_t instruction);
void MOVLI(cpu_t* cpu, uint16_t instruction);
void MOVBLG(cpu_t* cpu, uint16_t instruction);
void MOVWLG(cpu_t* cpu, uint16_t instruction);
void MOVLLG(cpu_t* cpu, uint16_t instruction);
void MOVBSG(cpu_t* cpu, uint16_t instruction);
void MOVWSG(cpu_t* cpu, uint16_t instruction);
void MOVLSG(cpu_t* cpu, uint16_t instruction);
void MOVBS4(cpu_t* cpu, uint16_t instruction);
void MOVWS4(cpu_t* cpu, uint16_t instruction);
void MOVLS4(cpu_t* cpu, uint16_t instruction);
void MOVBL4(cpu_t* cpu, uint16_t instruction);
void MOVWL4(cpu_t* cpu, uint16_t instruction);
void MOVLL4(cpu_t* cpu, uint16_t instruction);
void MOVA(cpu_t* cpu, uint16_t instruction);
void MOVT(cpu_t* cpu, uint16_t instruction);
void MULL(cpu_t* cpu, uint16_t instruction);
void MULS(cpu_t* cpu, uint16_t instruction);
void MULU(cpu_t* cpu, uint16_t instruction);
void NEG(cpu_t* cpu, uint16_t instruction);
void NEGC(cpu_t* cpu, uint16_t instruction);
void NOP(cpu_t* cpu, uint16_t instruction);
void NOT(cpu_t* cpu, uint16_t instruction);
void OR(cpu_t* cpu, uint16_t instruction);
void ORI(cpu_t* cpu, uint16_t instruction);
void ORM(cpu_t* cpu, uint16_t instruction);
void PREF(cpu_t* cpu, uint16_t instruction);
void ROTCL(cpu_t* cpu, uint16_t instruction);
void ROTCR(cpu_t* cpu, uint16_t instruction);
void ROTL(cpu_t* cpu, uint16_t instruction);
void ROTR(cpu_t* cpu, uint16_t instruction);
void RTE(cpu_t* cpu, uint16_t instruction);
void RTS(cpu_t* cpu, uint16_t instruction);
void SETS(cpu_t* cpu, uint16_t instruction);
void SETT(cpu_t* cpu, uint16_t instruction);
void SHAD(cpu_t* cpu, uint16_t instruction);
void SHAL(cpu_t* cpu, uint16_t instruction);
void SHAR(cpu_t* cpu, uint16_t instruction);
void SHLD(cpu_t* cpu, uint16_t instruction);
void SHLL(cpu_t* cpu, uint16_t instruction);
void SHLL2(cpu_t* cpu, uint16_t instruction);
void SHLL8(cpu_t* cpu, uint16_t instruction);
void SHLL16(cpu_t* cpu, uint16_t instruction);
void SHLR(cpu_t* cpu, uint16_t instruction);
void SHLR2(cpu_t* cpu, uint16_t instruction);
void SHLR8(cpu_t* cpu, uint16_t instruction);
void SHLR16(cpu_t* cpu, uint16_t instruction);
void STCGBR(cpu_t* cpu, uint16_t instruction);
void STCVBR(cpu_t* cpu, uint16_t instruction);
void STCSSR(cpu_t* cpu, uint16_t instruction);
void STCSPC(cpu_t* cpu, uint16_t instruction);
void STCSGR(cpu_t* cpu, uint16_t instruction);
void STCDBR(cpu_t* cpu, uint16_t instruction);
void STCMGBR(cpu_t* cpu, uint16_t instruction);
void STCMVBR(cpu_t* cpu, uint16_t instruction);
void STCMSSR(cpu_t* cpu, uint16_t instruction);
void STCMSPC(cpu_t* cpu, uint16_t instruction);
void STCMSGR(cpu_t* cpu, uint16_t instruction);
void STCMDBR(cpu_t* cpu, uint16_t instruction);
void STSMACH(cpu_t* cpu, uint16_t instruction);
void STSMACL(cpu_t* cpu, uint16_t instruction);
void STSPR(cpu_t* cpu, uint16_t instruction);
void STSMMACH(cpu_t* cpu, uint16_t instruction);
void STSMMACL(cpu_t* cpu, uint16_t instruction);
void STSMPR(cpu_t* cpu, uint16_t instruction);
void SUB(cpu_t* cpu, uint16_t instruction);
void SUBC(cpu_t* cpu, uint16_t instruction);
void SUBV(cpu_t* cpu, uint16_t instruction);
void SWAPB(cpu_t* cpu, uint16_t instruction);
void SWAPW(cpu_t* cpu, uint16_t instruction);
void TAS(cpu_t* cpu, uint16_t instruction);
void TST(cpu_t* cpu, uint16_t instruction);
void TSTI(cpu_t* cpu, uint16_t instruction);
void TSTM(cpu_t* cpu, uint16_t instruction);
void XOR(cpu_t* cpu, uint16_t instruction);
void XORI(cpu_t* cpu, uint16_t instruction);
void XORM(cpu_t* cpu, uint16_t instruction);
void XTRCT(cpu_t* cpu, uint16_t instruction);
void BSR(cpu_t* cpu, uint16_t instruction);
void BSRF(cpu_t* cpu, uint16_t instruction);
void JSR(cpu_t* cpu, uint16_t instruction);