#pragma once

#include "syscalls.h"

#define SAVEDISP_PAGE1 1
#define SAVEDISP_PAGE2 5
#define SAVEDISP_PAGE3 6

#define IMB_WRITEMODIFY_NORMAL  0x01
#define IMB_WRITEMODIFY_REVERSE 0x02

#define IMB_WRITEKIND_OVER          0x01
#define IMB_WRITEKIND_OR            0x02
#define IMB_WRITEKIND_AND           0x03
#define IMB_WRITEKIND_XOR           0x04

void syscall_Bdisp_AllClr_DD(cpu_t* cpu);
void syscall_Bdisp_AllClr_VRAM(cpu_t* cpu);
void syscall_Bdisp_AllClr_DDVRAM(cpu_t* cpu);
void syscall_Bdisp_PutDisp_DD(cpu_t* cpu);
void syscall_Bdisp_GetDisp_VRAM(cpu_t* cpu, uint32_t data_ptr);

void syscall_Bdisp_SetPoint_VRAM(cpu_t* cpu, uint32_t x, uint32_t y, uint32_t point);
void syscall_Bdisp_DrawLine_VRAM(cpu_t* cpu, uint32_t x1, uint32_t y1, uint32_t x2, uint32_t y2);
void syscall_Bdisp_ClearLine_VRAM(cpu_t* cpu, uint32_t x1, uint32_t y1, uint32_t x2, uint32_t y2);
void syscall_Bdisp_AreaReverseVRAM(cpu_t* cpu, uint32_t x1, uint32_t y1, uint32_t x2, uint32_t y2);
void syscall_Bdisp_WriteGraph_VRAM(cpu_t* cpu, uint32_t graph_ptr);

void syscall_SaveDisp(cpu_t* cpu, unsigned char num);
void syscall_RestoreDisp(cpu_t* cpu, unsigned char num);

void syscall_PopupWin(cpu_t* cpu, uint32_t n_lines);
void syscall_HourGlass(cpu_t* cpu);

void syscall_GetFKeyIconPointer(cpu_t* cpu, uint32_t key, uint32_t bitmap_ptr);
void syscall_DisplayFKeyIcon(cpu_t* cpu, uint32_t key_pos, uint32_t bitmap_ptr);