#pragma once

#include "syscalls.h"

// Drawing modes
#define TEXT_NORMAL  0
#define TEXT_REVERSE 1

// PrintMini drawing modes
#define MINI_OVER    0x10
#define MINI_OR      0x11
#define MINI_REV     0x12
#define MINI_REVOR   0x13

void syscall_Print(cpu_t* cpu, uint32_t str_ptr);
void syscall_PrintRev(cpu_t* cpu, uint32_t str_ptr);
void syscall_PrintC(cpu_t* cpu, uint32_t char_ptr);
void syscall_PrintRevC(cpu_t* cpu, uint32_t char_ptr);
void syscall_PrintXY(cpu_t* cpu, int x, int y, uint32_t str_ptr, int mode);
void syscall_PrintMini(cpu_t* cpu, int x, int y, uint32_t str_ptr, int mode);
void syscall_PrintLine(cpu_t* cpu, uint32_t str_ptr, uint32_t max);

void syscall_Locate(cpu_t* cpu, int x, int y);
void syscall_Cursor_SetPosition(cpu_t* cpu, uint32_t column, uint32_t row);
void syscall_Cursor_GetFlashStyle(cpu_t* cpu);
void syscall_Cursor_SetFlashOn(cpu_t* cpu, uint32_t flash_style);
void syscall_Cursor_SetFlashOff(cpu_t* cpu);
void syscall_Cursor_SetFlashMode(cpu_t* cpu, uint32_t flashmode);

void draw_cursor(cpu_t* cpu);